indexing
	description: "Representation of a week w/r/t a calendar"
	license: "Eiffel Forum License v2 - See license.txt"
	source: "{
		Amalasoft Corporation
		273 Harwood Avenue
		Littleton, MA 01460 USA
		}"
	status: "Copyright 1995-2008, Amalasoft"
	date: "$Date: 2008/04/26 $"
	revision: "$Revision: 002$"

class AEL_DT_CALENDAR_WEEK

inherit
	ARRAY [INTEGER]
		rename
			make as ar_make
		end

create
	make

feature {NONE} -- Creation and initialization

	make (wn: INTEGER; m: like month) is
		require
			week_number_valid: is_valid_week_number (wn)
			month_exists: m /= Void
		do
			ar_make (1, 7)
			week_number := wn
			month := m
			init_days
		end

	init_days is
		local
			fd, pos, idx, md: INTEGER
		do
			create days.make (1, 7)

			if week_number = 1 then
				fd := 1
				pos := month.first_day_position_in_week
			else
				pos := 1
				fd := month.first_day_in_week (week_number)
			end
			md := month.number_of_days

			from idx := 1
			until idx = pos
			loop
				put (0, idx)
				days.put ("", idx)
				idx := idx + 1
			end

			from idx := pos
			until idx > 7 or fd > md
			loop
				put (fd, idx)
				days.put (fd.out, idx)
				idx := idx + 1
				fd := fd + 1
			end

			from
			until idx > 7
			loop
				put (0, idx)
				days.put ("", idx)
				idx := idx + 1
			end
		end

feature -- Status

	days: ARRAY [STRING]

	week_number: INTEGER
	month: AEL_DT_CALENDAR_MONTH

	is_valid_week_number (wn: INTEGER): BOOLEAN is
		do
			Result := cal_routines.is_valid_week_number (wn)
		end

feature {NONE} -- Constants

	cal_const: AEL_DATE_TIME_CONSTANTS is
		once
			create Result
		end

	cal_routines: AEL_DATE_TIME_ROUTINES is
		once
			create Result
		end

end -- class AEL_DT_CALENDAR_WEEK
